#include "raytracing.h"

void cameraGetRes( struct Camera * cam, int * * ptr)
{
  int *res;

  res = (int *)malloc( sizeof(int)*2);
  res[0] = cam->y_res;
  res[1] = cam->x_res;
  *ptr = res;
}

void cameraGetUp( struct Camera * cam, double * * ptr)
{
  double *res;

  res = (double *)malloc( sizeof(double)*3);
  res[0] = cam->up.x;
  res[1] = cam->up.y;
  res[2] = cam->up.z;
  *ptr = res;
}

void cameraGetEye( struct Camera * cam, double * * ptr)
{
  double *res;

  res = (double *)malloc( sizeof(double)*3);
  res[0] = cam->eye.x;
  res[1] = cam->eye.y;
  res[2] = cam->eye.z;
  *ptr = res;
}

void cameraGetLookAt( struct Camera * cam, double * * ptr)
{
  double *res;

  res = (double *)malloc( sizeof(double)*3);
  res[0] = cam->lookat.x;
  res[1] = cam->lookat.y;
  res[2] = cam->lookat.z;
  *ptr = res;
}

void cameraGetWin( struct Camera * cam, double * * ptr)
{
  double *res;

  res = (double *)malloc( sizeof(double)*4);
  res[0] = cam->x_win.min;
  res[1] = cam->x_win.max;
  res[2] = cam->y_win.min;
  res[3] = cam->y_win.max;
  *ptr = res;
}

double cameraGetVpdist( struct Camera * cam)
{
  return( cam->vpdist);
}

