#include "interval.h"

double Len( struct Interval I )
{
    // Return the length of interval I.  If I is degenerate, the length is zero.
    double len = I.max - I.min;
    return len > 0.0 ? len : 0.0;
}


struct Interval intervalDiv( struct Interval I, double c )
{
    // Scale all elements of the interval I by 1/c.
    double a = I.min / c;
    double b = I.max / c;
	struct Interval I2;
	if( c >= 0.0 )
	{
		I2.min = a;
		I2.max = b;
	}
	else
	{
		I2.min = b;
		I2.max = a;
	}
    return I2;
}

bool intervalIsNull( struct Interval I )
{ 
    // Is the interval I degenerate?
    return I.max < I.min;
}
