

/*
 *  Global Switches
 */

#define SAC_DO_CHECK           0
#define SAC_DO_CHECK_TYPE      0
#define SAC_DO_CHECK_BOUNDARY  0
#define SAC_DO_CHECK_MALLOC    0
#define SAC_DO_CHECK_ERRNO     0
#define SAC_DO_CHECK_HEAP      0

#define SAC_DO_PHM             1
#define SAC_DO_APS             1
#define SAC_DO_DAO             1
#define SAC_DO_MSCA            1

#define SAC_DO_PROFILE         0
#define SAC_DO_PROFILE_WITH    0
#define SAC_DO_PROFILE_FUN     0
#define SAC_DO_PROFILE_INL     0
#define SAC_DO_PROFILE_LIB     0

#define SAC_DO_TRACE           0
#define SAC_DO_TRACE_REF       0
#define SAC_DO_TRACE_MEM       0
#define SAC_DO_TRACE_PRF       0
#define SAC_DO_TRACE_FUN       0
#define SAC_DO_TRACE_WL        0
#define SAC_DO_TRACE_AA        0
#define SAC_DO_TRACE_MT        0

#define SAC_DO_CACHESIM        0
#define SAC_DO_CACHESIM_ADV    0
#define SAC_DO_CACHESIM_GLOBAL 1
#define SAC_DO_CACHESIM_FILE   0
#define SAC_DO_CACHESIM_PIPE   0
#define SAC_DO_CACHESIM_IMDT   1

#define SAC_DO_MULTITHREAD     0
#define SAC_DO_THREADS_STATIC  1

#define SAC_MUTC_FUNAP_AS_CREATE  0
#define SAC_MUTC_THREAD_MALLOC 0
#define SAC_MUTC_DISABLE_THREAD_MEM 0
#define SAC_MUTC_BENCH 0
#define SAC_MUTC_MACROS  0

#define SAC_CUDA_MACROS  0

#define SAC_BACKEND C99

#define SAC_DO_COMPILE_MODULE  0
#define SAC_C_EXTERN           extern



/*
 *  Global Settings
 */

#ifndef NULL
#define NULL                      (void*) 0
#endif

#define SAC_SET_INITIAL_MASTER_HEAPSIZE      1048576
#define SAC_SET_INITIAL_WORKER_HEAPSIZE      65536
#define SAC_SET_INITIAL_UNIFIED_HEAPSIZE     0

#ifndef SAC_SET_MTMODE
#define SAC_SET_MTMODE               0
#endif

#ifndef SAC_SET_THREADS_MAX
#define SAC_SET_THREADS_MAX          32
#endif

#ifndef SAC_SET_THREADS
#define SAC_SET_THREADS              1
#endif

#ifndef SAC_SET_MASTERCLASS
#define SAC_SET_MASTERCLASS          0
#endif

#define SAC_SET_NUM_SCHEDULERS       0

#define SAC_SET_CACHE_1_SIZE         -1
#define SAC_SET_CACHE_1_LINE         4
#define SAC_SET_CACHE_1_ASSOC        1
#define SAC_SET_CACHE_1_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_1_MSCA_FACTOR  0.00

#define SAC_SET_CACHE_2_SIZE         -1
#define SAC_SET_CACHE_2_LINE         4
#define SAC_SET_CACHE_2_ASSOC        1
#define SAC_SET_CACHE_2_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_2_MSCA_FACTOR  0.00

#define SAC_SET_CACHE_3_SIZE         -1
#define SAC_SET_CACHE_3_LINE         4
#define SAC_SET_CACHE_3_ASSOC        1
#define SAC_SET_CACHE_3_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_3_MSCA_FACTOR  0.00

#define SAC_SET_CACHESIM_HOST        ""
#define SAC_SET_CACHESIM_FILE        "a.out.cs"
#define SAC_SET_CACHESIM_DIR         "/tmp"
#define SAC_SET_MAXFUN               0
#define SAC_SET_MAXFUNAP             1
#define SBLOCKSZ               16
#define LBLOCKSZ               256



/*
 *  Includes
 */


#include "sac.h"


#if SAC_CUDA_MACROS

#include <stdio.h>


#include <cutil.h>

#endif

/*
 *  SAC-Program test.sac :
 */


/*
 *  type definitions
 */

SAC_ND_TYPEDEF((SACt_World__World, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), SAC_hidden)
SAC_ND_TYPEDEF((SACt_Terminal__Terminal, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), SAC_hidden)
SAC_ND_TYPEDEF((SACt_TermFile__TermFile, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), SAC_hidden)
SAC_ND_TYPEDEF((SACt_ComplexBasics__complex, (AKS, (NHD, (NUQ, (FLO, (GLO, (NON, ))))))), double)
SAC_ND_TYPEDEF((SACt_Complex__complex, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), double)
SAC_ND_TYPEDEF((SACt_List__list, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), SAC_hidden)
SAC_C_EXTERN void SAC_List_free_list( SACt_List__list);

SAC_ND_TYPEDEF((SACt_IOresources__TermFile, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), SACt_TermFile__TermFile)
SAC_ND_TYPEDEF((SACt_sacprelude__SACarg, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), SAC_hidden)

SAC_C_EXTERN SACt_sacprelude__SACarg SACARGcopy( SACt_sacprelude__SACarg);
SAC_C_EXTERN void SACARGfree( SACt_sacprelude__SACarg);



/*
 *  Global Definitions
 */

SAC_MT_DEFINE()
SAC_PF_DEFINE()
SAC_HM_DEFINE()


/*
 *  prototypes for externals (FUNDECS)
 */

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( ARRAYIO__PrintIntArray, , 4, inout_nodesc_bx, SACt_TermFile__TermFile, (SACl_stream, (SCL, (HID, (NUQ, (INT, (GLO, (FPM, ))))))), in_nodesc, int, (SACl_d, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in_nodesc, int, (SACl_s, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in_nodesc, int, (SACl_a, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(ARRAYIO__PrintIntArray, void,  SAC_ND_PARAM_inout_nodesc_bx( (SACl_stream, (SCL, (HID, (NUQ, (INT, (GLO, (FPM, ))))))), SACt_TermFile__TermFile), SAC_ND_PARAM_in_nodesc( (SACl_d, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in_nodesc( (SACl_s, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in_nodesc( (SACl_a, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));



/*
 *  prototypes for locals (FUNDEFS)
 */

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__partitionIntersectMax__i_S__i_S, , 3, out, int, (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idxmin, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_bound1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__partitionIntersectMax__i_S__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_idxmin, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_bound1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__partitionSlicer__i_S__i_S__i_S__i_S__i_S, , 9, out, int, (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), out, int, (SAC_arg_2, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), out, int, (SAC_arg_3, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), out, int, (SAC_arg_4, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_min, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_max, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_axis, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_lb, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_ub, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__partitionSlicer__i_S__i_S__i_S__i_S__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_out( (SAC_arg_2, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_out( (SAC_arg_3, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_out( (SAC_arg_4, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_min, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_max, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_axis, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_lb, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_ub, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__isPartitionIntersectNull__i_S__i_S__i_S__i_S, , 5, out, bool, (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idxmin, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idxmax, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_bound1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_bound2, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__isPartitionIntersectNull__i_S__i_S__i_S__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_idxmin, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_idxmax, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_bound1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_bound2, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__partitionIntersectMin__i_S__i_S, , 3, out, int, (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idxmax, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_bound2, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__partitionIntersectMin__i_S__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_idxmax, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_bound2, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__adjustLacFunParams__bl_S__i_S__i_S, , 4, out, int, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_p, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_i, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_iv, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__adjustLacFunParams__bl_S__i_S__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_p, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_i, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_iv, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf__MAIN__main, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__adjustLacFunParamsReshape__bl_S__i_S__i_S__i_S, , 5, out, int, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_p, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_i, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_iv, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_shp, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__adjustLacFunParamsReshape__bl_S__i_S__i_S__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_p, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_i, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_iv, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_shp, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__ull_S__ull_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulonglong, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulonglong, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__ull_S__ull_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulonglong), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulonglong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__ul_S__ul_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulong, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulong, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__ul_S__ul_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulong), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__ui_S__ui_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, uint, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, uint, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__ui_S__ui_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), uint), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), uint));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__us_S__us_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ushort, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ushort, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__us_S__us_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ushort), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ushort));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__ub_S__ub_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ubyte, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ubyte, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__ub_S__ub_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ubyte), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ubyte));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__ll_S__ll_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, longlong, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, longlong, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__ll_S__ll_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), longlong), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), longlong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__l_S__l_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, long, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, long, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__l_S__l_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), long), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), long));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__s_S__s_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, short, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, short, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__s_S__s_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), short), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), short));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__b_S__b_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, byte, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, byte, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__b_S__b_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), byte), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), byte));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__c_S__c_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, unsigned char, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, unsigned char, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__c_S__c_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), unsigned char), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), unsigned char));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__bl_S__bl_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__bl_S__bl_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__d_S__d_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, double, (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), in, double, (SACl_B, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__d_S__d_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), double), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), double));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__f_S__f_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, float, (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), in, float, (SACl_B, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__f_S__f_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), float), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), float));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__eq__i_S__i_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__eq__i_S__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__gridFiller__i_S__i_S__i_S__i_S__i_S, , 8, out, int, (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), out, int, (SAC_arg_2, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), out, int, (SAC_arg_3, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_lb, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_ub, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_wdth, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_dim, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_maxwidth, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__gridFiller__i_S__i_S__i_S__i_S__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_out( (SAC_arg_2, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_out( (SAC_arg_3, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_lb, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_ub, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_wdth, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_dim, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_maxwidth, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__ull_S, , 2, out, ulonglong, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulonglong, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__ull_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulonglong), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulonglong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__ul_S, , 2, out, ulong, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulong, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__ul_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulong), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__ui_S, , 2, out, uint, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, uint, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__ui_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), uint), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), uint));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__us_S, , 2, out, ushort, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ushort, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__us_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ushort), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ushort));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__ub_S, , 2, out, ubyte, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ubyte, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__ub_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ubyte), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ubyte));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__ll_S, , 2, out, longlong, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, longlong, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__ll_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), longlong), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), longlong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__l_S, , 2, out, long, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, long, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__l_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), long), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), long));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__s_S, , 2, out, short, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, short, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__s_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), short), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), short));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__b_S, , 2, out, byte, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, byte, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__b_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), byte), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), byte));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__bl_S, , 2, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__bl_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__c_S, , 2, out, unsigned char, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, unsigned char, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__c_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), unsigned char), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), unsigned char));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__f_S, , 2, out, float, (SAC_arg_1, (SCL, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), in, float, (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__f_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), float), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), float));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__d_S, , 2, out, double, (SAC_arg_1, (SCL, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), in, double, (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__d_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), double), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), double));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__zero__i_S, , 2, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__zero__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__ull_S, , 3, out, ulonglong, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulonglong, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__ull_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulonglong), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulonglong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__ul_S, , 3, out, ulong, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulong, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__ul_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulong), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__ui_S, , 3, out, uint, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, uint, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__ui_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), uint), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), uint));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__us_S, , 3, out, ushort, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ushort, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__us_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ushort), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ushort));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__ub_S, , 3, out, ubyte, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ubyte, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__ub_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ubyte), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ubyte));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__ll_S, , 3, out, longlong, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, longlong, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__ll_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), longlong), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), longlong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__l_S, , 3, out, long, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, long, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__l_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), long), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), long));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__s_S, , 3, out, short, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, short, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__s_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), short), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), short));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__b_S, , 3, out, byte, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, byte, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__b_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), byte), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), byte));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__c_S, , 3, out, unsigned char, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, unsigned char, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__c_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), unsigned char), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), unsigned char));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__bl_S, , 3, out, bool, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__bl_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__d_S, , 3, out, double, (SAC_arg_1, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, double, (SACl_array, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__d_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), double), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), double));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__f_S, , 3, out, float, (SAC_arg_1, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, float, (SACl_array, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__f_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), float), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), float));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACwf_sacprelude__sel__i_S__i_S, , 3, out, int, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACwf_sacprelude__sel__i_S__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_idx, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf__MAIN__main, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf__MAIN_CL_INIT__init, , 0)
 */
SAC_ND_DECL_FUN2(SACf__MAIN_CL_INIT__init, void, );

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_World_CL_INIT__init_TheWorld__SACt_World__World, , 1, inout, SACt_World__World, (SACp_OI_object, (SCL, (HID, (NUQ, (INT, (GLO, (FPO, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_World_CL_INIT__init_TheWorld__SACt_World__World, void,  SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (HID, (NUQ, (INT, (GLO, (FPO, ))))))), SACt_World__World));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal, , 1, inout, SACt_Terminal__Terminal, (SACp_OI_object, (SCL, (HID, (NUQ, (INT, (GLO, (FPO, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal, void,  SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (HID, (NUQ, (INT, (GLO, (FPO, ))))))), SACt_Terminal__Terminal));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile, , 1, inout, SACt_TermFile__TermFile, (SACp_OI_object, (SCL, (HID, (NUQ, (INT, (GLO, (FPO, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile, void,  SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (HID, (NUQ, (INT, (GLO, (FPO, ))))))), SACt_TermFile__TermFile));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_jfdctint__jpeg_fdct_islow__i_64, , 2, out, int, (SAC_arg_1, (AKS, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_data, (AKS, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_jfdctint__jpeg_fdct_islow__i_64, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AKS, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_data, (AKS, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__i_S, , 3, out, int, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__f_S, , 3, out, float, (SAC_arg_1, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, float, (SACl_array, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__f_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), float), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), float));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__d_S, , 3, out, double, (SAC_arg_1, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, double, (SACl_array, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__d_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), double), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), double));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__bl_S, , 3, out, bool, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__bl_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__c_S, , 3, out, unsigned char, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, unsigned char, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__c_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), unsigned char), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), unsigned char));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__b_S, , 3, out, byte, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, byte, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__b_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), byte), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), byte));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__s_S, , 3, out, short, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, short, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__s_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), short), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), short));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__l_S, , 3, out, long, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, long, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__l_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), long), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), long));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__ll_S, , 3, out, longlong, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, longlong, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__ll_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), longlong), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), longlong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__ub_S, , 3, out, ubyte, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ubyte, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__ub_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ubyte), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ubyte));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__us_S, , 3, out, ushort, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ushort, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__us_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ushort), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ushort));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__ui_S, , 3, out, uint, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, uint, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__ui_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), uint), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), uint));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__ul_S, , 3, out, ulong, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulong, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__ul_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulong), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__sel__i_X__ull_S, , 3, out, ulonglong, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulonglong, (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__sel__i_X__ull_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulonglong), SAC_ND_PARAM_in( (SACl_idx, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_array, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulonglong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__i_S, , 2, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__d_S, , 2, out, double, (SAC_arg_1, (SCL, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), in, double, (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__d_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), double), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), double));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__f_S, , 2, out, float, (SAC_arg_1, (SCL, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), in, float, (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__f_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), float), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), float));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__c_S, , 2, out, unsigned char, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, unsigned char, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__c_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), unsigned char), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), unsigned char));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__bl_S, , 2, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__bl_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__b_S, , 2, out, byte, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, byte, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__b_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), byte), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), byte));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__s_S, , 2, out, short, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, short, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__s_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), short), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), short));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__l_S, , 2, out, long, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, long, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__l_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), long), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), long));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__ll_S, , 2, out, longlong, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, longlong, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__ll_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), longlong), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), longlong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__ub_S, , 2, out, ubyte, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ubyte, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__ub_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ubyte), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ubyte));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__us_S, , 2, out, ushort, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ushort, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__us_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ushort), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ushort));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__ui_S, , 2, out, uint, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, uint, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__ui_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), uint), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), uint));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__ul_S, , 2, out, ulong, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulong, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__ul_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulong), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__zero__ull_S, , 2, out, ulonglong, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulonglong, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__zero__ull_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulonglong), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulonglong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__i_S__i_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__i_S__i_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__f_S__f_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, float, (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), in, float, (SACl_B, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__f_S__f_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), float), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), float));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__d_S__d_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, double, (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), in, double, (SACl_B, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__d_S__d_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), double), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (FLO, (GLO, (FPM, ))))))), double));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__bl_S__bl_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__bl_S__bl_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__c_S__c_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, unsigned char, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, unsigned char, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__c_S__c_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), unsigned char), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), unsigned char));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__b_S__b_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, byte, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, byte, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__b_S__b_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), byte), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), byte));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__s_S__s_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, short, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, short, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__s_S__s_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), short), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), short));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__l_S__l_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, long, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, long, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__l_S__l_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), long), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), long));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__ll_S__ll_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, longlong, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, longlong, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__ll_S__ll_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), longlong), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), longlong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__ub_S__ub_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ubyte, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ubyte, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__ub_S__ub_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ubyte), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ubyte));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__us_S__us_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ushort, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ushort, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__us_S__us_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ushort), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ushort));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__ui_S__ui_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, uint, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, uint, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__ui_S__ui_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), uint), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), uint));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__ul_S__ul_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulong, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulong, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__ul_S__ul_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulong), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__eq__ull_S__ull_S, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulonglong, (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, ulonglong, (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__eq__ull_S__ull_S, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_A, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulonglong), SAC_ND_PARAM_in( (SACl_B, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), ulonglong));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__adjustLacFunParams__bl_S__i_S__i_X, , 4, out, int, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_p, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_i, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_iv, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__adjustLacFunParams__bl_S__i_S__i_X, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_p, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_i, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_iv, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__adjustLacFunParamsReshape__bl_S__i_S__i_X__i_X, , 5, out, int, (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_p, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_i, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_iv, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_shp, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__adjustLacFunParamsReshape__bl_S__i_S__i_X__i_X, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_p, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_i, (AUD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_iv, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_shp, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__partitionSlicer__i_X__i_X__i__i_X__i_X, , 9, out, int, (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), out, int, (SAC_arg_2, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), out, int, (SAC_arg_3, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), out, int, (SAC_arg_4, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_min, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_max, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_axis, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_lb, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_ub, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__partitionSlicer__i_X__i_X__i__i_X__i_X, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_out( (SAC_arg_2, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_out( (SAC_arg_3, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_out( (SAC_arg_4, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_min, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_max, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_axis, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_lb, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_ub, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__gridFiller__i_X__i_X__i_X__i__i_X, , 8, out, int, (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), out, int, (SAC_arg_2, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), out, int, (SAC_arg_3, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_lb, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_ub, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_wdth, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_dim, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_maxwidth, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__gridFiller__i_X__i_X__i_X__i__i_X, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_out( (SAC_arg_2, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_out( (SAC_arg_3, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_lb, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_ub, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_wdth, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_dim, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_maxwidth, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__partitionIntersectMax__i_X__i_X, , 3, out, int, (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idxmin, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_bound1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__partitionIntersectMax__i_X__i_X, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_idxmin, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_bound1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__partitionIntersectMin__i_X__i_X, , 3, out, int, (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idxmax, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_bound2, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__partitionIntersectMin__i_X__i_X, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_idxmax, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_bound2, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__isPartitionIntersectNull__i_X__i_X__i_X__i_X, , 5, out, bool, (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idxmin, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_idxmax, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_bound1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, int, (SACl_bound2, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__isPartitionIntersectNull__i_X__i_X__i_X__i_X, void,  SAC_ND_PARAM_out( (SAC_arg_1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_idxmin, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_idxmax, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_bound1, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int), SAC_ND_PARAM_in( (SACl_bound2, (AKD, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int));

SAC_C_EXTERN 
/*
 * ND_FUN_DECL( SACf_sacprelude__and__bl__bl, , 3, out, bool, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_a, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), in, bool, (SACl_b, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DECL_FUN2(SACf_sacprelude__and__bl__bl, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_a, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool), SAC_ND_PARAM_in( (SACl_b, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), bool));



/*
 *  global objects
 */

/*
 * ND_OBJDEF_EXTERN( (SACo_World__TheWorld, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), SACt_World__World, 0)
 */
SAC_ND_DECL__DATA( (SACo_World__TheWorld, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), SACt_World__World, extern)
SAC_ND_DECL__DESC( (SACo_World__TheWorld, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), extern)
SAC_NOTHING()

/*
 * ND_OBJDEF_EXTERN( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), SACt_Terminal__Terminal, 0)
 */
SAC_ND_DECL__DATA( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), SACt_Terminal__Terminal, extern)
SAC_ND_DECL__DESC( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), extern)
SAC_NOTHING()

/*
 * ND_OBJDEF_EXTERN( (SACo_TermFile__stdout, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), SACt_TermFile__TermFile, 0)
 */
SAC_ND_DECL__DATA( (SACo_TermFile__stdout, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), SACt_TermFile__TermFile, extern)
SAC_ND_DECL__DESC( (SACo_TermFile__stdout, (SCL, (HID, (NUQ, (INT, (GLO, (NON, ))))))), extern)
SAC_NOTHING()



/*
 *  function definitions (FUNDEFS)
 */



/****************************************************************************
 * Wrapper function:
 * SACwf__MAIN__main(...)
 ****************************************************************************/
/*
 * ND_FUN_DEF_BEGIN( SACwf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DEF_FUN_BEGIN2(SACwf__MAIN__main, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int))
{
  SAC_HM_DEFINE_THREAD_STATUS( SAC_HM_single_threaded)

  { 
    /*
     * ND_DECL( (SACp_emal_1545__cwc_69, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, 0)
     */
    SAC_ND_DECL__DATA( (SACp_emal_1545__cwc_69, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
    SAC_ND_DECL__DESC( (SACp_emal_1545__cwc_69, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    SAC_NOTHING()

    /*
     * ND_DECL( (SACp_cwc_70, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, 0)
     */
    SAC_ND_DECL__DATA( (SACp_cwc_70, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
    SAC_ND_DECL__DESC( (SACp_cwc_70, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    SAC_NOTHING()


    /*
     * ND_FUN_AP( SACf__MAIN__main, , 1, out, int, SAC_SET_NT_USG( FAG, (SACp_cwc_70, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))))
     */
    SAC_ND_FUNAP2(SACf__MAIN__main,  SAC_ND_ARG_out( SAC_SET_NT_USG( FAG, (SACp_cwc_70, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), int))

    /*
     * ND_REFRESH__MIRROR( (SACp_cwc_70, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0)
     */
    SAC_NOOP()

    SAC_ND_FREE((SACp_cwc_70, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    SAC_ND_ALLOC_BEGIN((SACp_emal_1545__cwc_69, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 0, int)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_1545__cwc_69, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1545__cwc_69, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 0), 5, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END((SACp_emal_1545__cwc_69, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 0, int)
    SAC_ND_CREATE__SCALAR__DATA((SACp_emal_1545__cwc_69, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0)
    /*
     * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), (SACp_emal_1545__cwc_69, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))))
     */
    SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), (SACp_emal_1545__cwc_69, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))))
    return;
  }
/*
   * ND_FUN_DEF_END( SACwf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
   */
}
SAC_ND_FUN_DEF_END2();



/****************************************************************************
 * SACf__MAIN__main(...)
 ****************************************************************************/
/*
 * ND_FUN_DEF_BEGIN( SACf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
 */
SAC_ND_DEF_FUN_BEGIN2(SACf__MAIN__main, void,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), int))
{
  SAC_HM_DEFINE_THREAD_STATUS( SAC_HM_single_threaded)

  { 
    /*
     * ND_DECL( (SACp_emrb_1959_mem, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), bool, 0)
     */
    SAC_ND_DECL__DATA( (SACp_emrb_1959_mem, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), bool, )
    SAC_ND_DECL__DESC( (SACp_emrb_1959_mem, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    SAC_NOTHING()

    /*
     * ND_DECL( (SACp_emal_1553__isaa_189__rso_8_TheWorld, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, 0)
     */
    SAC_ND_DECL__DATA( (SACp_emal_1553__isaa_189__rso_8_TheWorld, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
    SAC_ND_DECL__DESC( (SACp_emal_1553__isaa_189__rso_8_TheWorld, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    SAC_NOTHING()

    /*
     * ND_DECL( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, 1, 64)
     */
    SAC_ND_DECL__DATA( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
    SAC_ND_DECL__DESC( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) = 64;
    const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 64;
    const int SAC_ND_A_MIRROR_DIM( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 1;

    /*
     * ND_DECL( (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, 1, 2)
     */
    SAC_ND_DECL__DATA( (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
    SAC_ND_DECL__DESC( (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) = 2;
    const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 2;
    const int SAC_ND_A_MIRROR_DIM( (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 1;

    /*
     * ND_DECL( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, 2, 8, 8)
     */
    SAC_ND_DECL__DATA( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
    SAC_ND_DECL__DESC( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) = 8;
    const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1) = 8;
    const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 64;
    const int SAC_ND_A_MIRROR_DIM( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 2;

    /*
     * ND_DECL( (SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, 0)
     */
    SAC_ND_DECL__DATA( (SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
    SAC_ND_DECL__DESC( (SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    SAC_NOTHING()

    /*
     * ND_DECL( (SACp_emal_1548__isaa_210_y, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, 0)
     */
    SAC_ND_DECL__DATA( (SACp_emal_1548__isaa_210_y, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
    SAC_ND_DECL__DESC( (SACp_emal_1548__isaa_210_y, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    SAC_NOTHING()

    /*
     * ND_DECL( (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, 1, 1)
     */
    SAC_ND_DECL__DATA( (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
    SAC_ND_DECL__DESC( (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) = 1;
    const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 1;
    const int SAC_ND_A_MIRROR_DIM( (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 1;

    /*
     * ND_DECL( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, 2, 8, 8)
     */
    SAC_ND_DECL__DATA( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
    SAC_ND_DECL__DESC( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) = 8;
    const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1) = 8;
    const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 64;
    const int SAC_ND_A_MIRROR_DIM( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 2;

    /*
     * ND_DECL( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, 2, 8, 8)
     */
    SAC_ND_DECL__DATA( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
    SAC_ND_DECL__DESC( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    const int SAC_ND_A_MIRROR_SHAPE( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) = 8;
    const int SAC_ND_A_MIRROR_SHAPE( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1) = 8;
    const int SAC_ND_A_MIRROR_SIZE( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 64;
    const int SAC_ND_A_MIRROR_DIM( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 2;

    /*
     * ND_DECL( (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, 1, 64)
     */
    SAC_ND_DECL__DATA( (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
    SAC_ND_DECL__DESC( (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    const int SAC_ND_A_MIRROR_SHAPE( (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) = 64;
    const int SAC_ND_A_MIRROR_SIZE( (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 64;
    const int SAC_ND_A_MIRROR_DIM( (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = 1;


    SAC_ND_ALLOC_BEGIN((SACp_emal_1553__isaa_189__rso_8_TheWorld, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 0, int)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_1553__isaa_189__rso_8_TheWorld, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1553__isaa_189__rso_8_TheWorld, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 0), 5, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END((SACp_emal_1553__isaa_189__rso_8_TheWorld, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 0, int)
    SAC_ND_CREATE__SCALAR__DATA((SACp_emal_1553__isaa_189__rso_8_TheWorld, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0)
    /*
     * ND_FUN_AP( SACf__MAIN_CL_INIT__init, , 0)
     */
    SAC_ND_FUNAP2(SACf__MAIN_CL_INIT__init, )

    SAC_ND_ALLOC_BEGIN((SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 1, int)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 64)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 1), 6, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) == 64), 6, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END((SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 1, int)
    /*
     * ND_CREATE__ARRAY__DATA( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 64, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, )
     */
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 2, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 3, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 4, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 5, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 6, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 7, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 8, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 9, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 10, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 11, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 12, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 13, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 14, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 15, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 16, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 17, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 18, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 19, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 20, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 21, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 22, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 23, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 24, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 25, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 26, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 27, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 28, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 29, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 30, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 31, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 32, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 33, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 34, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 35, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 36, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 37, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 38, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 39, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 40, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 41, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 42, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 43, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 44, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 45, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 46, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 47, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 48, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 49, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 50, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 51, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 52, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 53, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 54, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 55, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 56, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 57, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 58, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 59, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 60, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 61, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 62, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 63, 14, )

    SAC_ND_ALLOC_BEGIN((SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 1, int)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 2)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 1), 7, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) == 2), 7, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END((SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 1, int)
    /*
     * ND_CREATE__ARRAY__DATA( (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 2, 8, 8, )
     */
    SAC_ND_WRITE_COPY( (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 8, )

    SAC_ND_ALLOC_BEGIN((SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 2, int)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 2, 8, 8)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 2), 62, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) == 8), 62, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1) == 8), 62, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END((SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 2, int)
    /*
     * ND_CREATE__ARRAY__DATA( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 2, 64, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, 3, 4, 5, 6, 7, 8, 13, 14, )
     */
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 2, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 3, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 4, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 5, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 6, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 7, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 8, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 9, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 10, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 11, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 12, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 13, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 14, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 15, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 16, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 17, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 18, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 19, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 20, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 21, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 22, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 23, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 24, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 25, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 26, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 27, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 28, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 29, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 30, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 31, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 32, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 33, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 34, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 35, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 36, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 37, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 38, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 39, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 40, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 41, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 42, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 43, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 44, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 45, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 46, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 47, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 48, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 49, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 50, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 51, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 52, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 53, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 54, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 55, 14, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 56, 3, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 57, 4, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 58, 5, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 59, 6, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 60, 7, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 61, 8, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 62, 13, )
    SAC_ND_WRITE_COPY( (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 63, 14, )

    SAC_ND_ALLOC_BEGIN((SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 0, int)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 0), 23, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END((SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 0, int)
    SAC_ND_CREATE__SCALAR__DATA((SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 2)
    /*
     * ND_FUN_AP( ARRAYIO__PrintIntArray, , 4, inout_nodesc_bx, SACt_TermFile__TermFile, SAC_SET_NT_USG( TFA, (SACo_TermFile__stdout, (SCL, (HID, (NUQ, (INT, (GLO, (NON, )))))))), in_nodesc, int, SAC_SET_NT_USG( FAG, (SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), in_nodesc, int, SAC_SET_NT_USG( FAG, (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), in_nodesc, int, SAC_SET_NT_USG( FAG, (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))))
     */
    SAC_ND_FUNAP2(ARRAYIO__PrintIntArray,  SAC_ND_ARG_inout_nodesc_bx( SAC_SET_NT_USG( TFA, (SACo_TermFile__stdout, (SCL, (HID, (NUQ, (INT, (GLO, (NON, )))))))), SACt_TermFile__TermFile), SAC_ND_ARG_in_nodesc( SAC_SET_NT_USG( FAG, (SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), int), SAC_ND_ARG_in_nodesc( SAC_SET_NT_USG( FAG, (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), int), SAC_ND_ARG_in_nodesc( SAC_SET_NT_USG( FAG, (SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), int))

    SAC_ND_DEC_RC_FREE((SACp_emal_1550__flat_0, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, )
    /*
     * ND_FUN_AP( SACf_jfdctint__jpeg_fdct_islow__i_64, , 2, out, int, SAC_SET_NT_USG( FAG, (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), in, int, SAC_SET_NT_USG( FAG, (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))))
     */
    SAC_ND_FUNAP2(SACf_jfdctint__jpeg_fdct_islow__i_64,  SAC_ND_ARG_out( SAC_SET_NT_USG( FAG, (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), int), SAC_ND_ARG_in( SAC_SET_NT_USG( FAG, (SACp_emal_1552_i, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), int))

    /*
     * ND_REFRESH__MIRROR( (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1)
     */
    SAC_NOOP()

    SAC_ND_ALLOC_BEGIN((SACp_emal_1548__isaa_210_y, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 0, int)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_1548__isaa_210_y, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1548__isaa_210_y, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 0), 8, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END((SACp_emal_1548__isaa_210_y, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 0, int)
    SAC_ND_CREATE__SCALAR__DATA((SACp_emal_1548__isaa_210_y, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1)
    SAC_ND_ALLOC_BEGIN((SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 1, int)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 1)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 1), 8, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) == 1), 8, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END((SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 1, int)
    /*
     * ND_CREATE__ARRAY__DATA( (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 1, 64, )
     */
    SAC_ND_WRITE_COPY( (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0, 64, )

    /*
     * ND_FUN_AP( ARRAYIO__PrintIntArray, , 4, inout_nodesc_bx, SACt_TermFile__TermFile, SAC_SET_NT_USG( TFA, (SACo_TermFile__stdout, (SCL, (HID, (NUQ, (INT, (GLO, (NON, )))))))), in_nodesc, int, SAC_SET_NT_USG( FAG, (SACp_emal_1548__isaa_210_y, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), in_nodesc, int, SAC_SET_NT_USG( FAG, (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), in_nodesc, int, SAC_SET_NT_USG( FAG, (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))))
     */
    SAC_ND_FUNAP2(ARRAYIO__PrintIntArray,  SAC_ND_ARG_inout_nodesc_bx( SAC_SET_NT_USG( TFA, (SACo_TermFile__stdout, (SCL, (HID, (NUQ, (INT, (GLO, (NON, )))))))), SACt_TermFile__TermFile), SAC_ND_ARG_in_nodesc( SAC_SET_NT_USG( FAG, (SACp_emal_1548__isaa_210_y, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), int), SAC_ND_ARG_in_nodesc( SAC_SET_NT_USG( FAG, (SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), int), SAC_ND_ARG_in_nodesc( SAC_SET_NT_USG( FAG, (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), int))

    SAC_ND_DEC_RC_FREE((SACp_emal_1547__isaa_211_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, )
    SAC_ND_DEC_RC_FREE((SACp_emal_1548__isaa_210_y, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, )
    SAC_IS_LASTREF__BLOCK_BEGIN((SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))))
    SAC_ND_ALLOC__DESC((SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 2)
    SAC_ND_FREE__DESC((SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))))
    /*
     * ND_ASSIGN__DESC( (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))))
     */
    SAC_ND_A_DESC( (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = SAC_ND_A_DESC( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))));

    SAC_ND_SET__RC((SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 2, 8, 8)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 2), 62, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) == 8), 62, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1) == 8), 62, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ASSIGN__DATA((SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
    SAC_ND_INC_RC((SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1)
    SAC_IS_LASTREF__BLOCK_ELSE((SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))))
    SAC_ND_ALLOC_BEGIN((SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 2, int)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 2, 8, 8)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 2), 62, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) == 8), 62, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1) == 8), 62, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END((SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 2, int)
    SAC_IS_LASTREF__BLOCK_END((SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))))
    SAC_ND_ALLOC_BEGIN((SACp_emrb_1959_mem, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 0, bool)
    /*
     * ND_SET__SHAPE_arr( (SACp_emrb_1959_mem, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emrb_1959_mem, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 0), 62, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END((SACp_emrb_1959_mem, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 0, bool)
    SAC_ND_PRF_IS_REUSED((SACp_emrb_1959_mem, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))))
    if (SAC_ND_GETVAR((SACp_emrb_1959_mem, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), SACp_emrb_1959_mem)) 
    { 
      SAC_ND_DEC_RC_FREE((SACp_emrb_1959_mem, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, )
      SAC_NOOP()
      SAC_ND_DEC_RC_FREE((SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, )
      /*
       * ND_ASSIGN( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 2, (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 2, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 2), 62, "Assignment with incompatible types found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) == SAC_ND_A_SHAPE( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0)), 62, "Assignment with incompatible types found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1) == SAC_ND_A_SHAPE( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1)), 62, "Assignment with incompatible types found!");
      SAC_ND_A_DESC( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = SAC_ND_A_DESC( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))));
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )

    }
    else
    { 
      SAC_ND_DEC_RC_FREE((SACp_emrb_1959_mem, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, )
      SAC_ND_COPY__DATA((SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), (SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
      SAC_ND_DEC_RC_FREE((SACl_y, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, )
      /*
       * ND_ASSIGN( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 2, (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 2, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 2), 62, "Assignment with incompatible types found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0) == SAC_ND_A_SHAPE( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0)), 62, "Assignment with incompatible types found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1) == SAC_ND_A_SHAPE( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1)), 62, "Assignment with incompatible types found!");
      SAC_ND_A_DESC( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) = SAC_ND_A_DESC( (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))));
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), (SACp_emal_1546__flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )

    }
    /*
     * ND_FUN_AP( ARRAYIO__PrintIntArray, , 4, inout_nodesc_bx, SACt_TermFile__TermFile, SAC_SET_NT_USG( TFA, (SACo_TermFile__stdout, (SCL, (HID, (NUQ, (INT, (GLO, (NON, )))))))), in_nodesc, int, SAC_SET_NT_USG( FAG, (SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), in_nodesc, int, SAC_SET_NT_USG( FAG, (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), in_nodesc, int, SAC_SET_NT_USG( FAG, (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))))
     */
    SAC_ND_FUNAP2(ARRAYIO__PrintIntArray,  SAC_ND_ARG_inout_nodesc_bx( SAC_SET_NT_USG( TFA, (SACo_TermFile__stdout, (SCL, (HID, (NUQ, (INT, (GLO, (NON, )))))))), SACt_TermFile__TermFile), SAC_ND_ARG_in_nodesc( SAC_SET_NT_USG( FAG, (SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), int), SAC_ND_ARG_in_nodesc( SAC_SET_NT_USG( FAG, (SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), int), SAC_ND_ARG_in_nodesc( SAC_SET_NT_USG( FAG, (SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, )))))))), int))

    SAC_ND_DEC_RC_FREE((SACp_flat_2, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, )
    SAC_ND_DEC_RC_FREE((SACp_emal_1551__flat_1, (AKS, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, )
    SAC_ND_DEC_RC_FREE((SACp_emal_1549__pinl_130__flat_76, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, )
    /*
     * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), (SACp_emal_1553__isaa_189__rso_8_TheWorld, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))))
     */
    SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))), (SACp_emal_1553__isaa_189__rso_8_TheWorld, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))))
    return;
  }
/*
   * ND_FUN_DEF_END( SACf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (FPM, ))))))))
   */
}
SAC_ND_FUN_DEF_END2();



/****************************************************************************
 * SACf__MAIN_CL_INIT__init(...)
 ****************************************************************************/
/*
 * ND_FUN_DEF_BEGIN( SACf__MAIN_CL_INIT__init, , 0)
 */
SAC_ND_DEF_FUN_BEGIN2(SACf__MAIN_CL_INIT__init, void, )
{
  SAC_HM_DEFINE_THREAD_STATUS( SAC_HM_single_threaded)

  { 
    /*
     * ND_FUN_AP( SACf_World_CL_INIT__init_TheWorld__SACt_World__World, , 1, inout, SACt_World__World, SAC_SET_NT_USG( TFA, (SACo_World__TheWorld, (SCL, (HID, (NUQ, (INT, (GLO, (NON, )))))))))
     */
    SAC_ND_FUNAP2(SACf_World_CL_INIT__init_TheWorld__SACt_World__World,  SAC_ND_ARG_inout( SAC_SET_NT_USG( TFA, (SACo_World__TheWorld, (SCL, (HID, (NUQ, (INT, (GLO, (NON, )))))))), SACt_World__World))

    /*
     * ND_FUN_AP( SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal, , 1, inout, SACt_Terminal__Terminal, SAC_SET_NT_USG( TFA, (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ, (INT, (GLO, (NON, )))))))))
     */
    SAC_ND_FUNAP2(SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal,  SAC_ND_ARG_inout( SAC_SET_NT_USG( TFA, (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ, (INT, (GLO, (NON, )))))))), SACt_Terminal__Terminal))

    /*
     * ND_FUN_AP( SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile, , 1, inout, SACt_TermFile__TermFile, SAC_SET_NT_USG( TFA, (SACo_TermFile__stdout, (SCL, (HID, (NUQ, (INT, (GLO, (NON, )))))))))
     */
    SAC_ND_FUNAP2(SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile,  SAC_ND_ARG_inout( SAC_SET_NT_USG( TFA, (SACo_TermFile__stdout, (SCL, (HID, (NUQ, (INT, (GLO, (NON, )))))))), SACt_TermFile__TermFile))

    /*
     * ND_FUN_RET( , 0)
     */
    return;
  }
/*
   * ND_FUN_DEF_END( SACf__MAIN_CL_INIT__init, , 0)
   */
}
SAC_ND_FUN_DEF_END2();

/*
 * stubs for SACARGfreeDataUdt and SACARGcopyDataUdt
 */
extern void SACARGfreeDataUdt( int, void *);
extern void *SACARGcopyDataUdt( int, int, void *);
void SACARGfreeDataUdt( int size, void *data) {};
void *SACARGcopyDataUdt( int type, int size, void *data) { return ((void *) 0x0); } 

int main( int __argc, char *__argv[])
{
  SAC_ND_DECL__DATA( (SAC_res, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )
  SAC_ND_DECL__DESC( (SAC_res, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )
  SAC_NOTHING()
  SAC_MT_SETUP_INITIAL();
  SAC_PF_SETUP();
  SAC_HM_SETUP();
  SAC_MT_SETUP();
  SAC_CS_SETUP();
  SAC_COMMANDLINE_SET( __argc, __argv);

  SACf__MAIN__main( SAC_ND_ARG_out( (SAC_res, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int));

  SAC_PF_PRINT();
  SAC_CS_FINALIZE();
  SAC_HM_PRINT();

  return( SAC_ND_READ( (SAC_res, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0));
}
